config/routes.rb
# frozen_string_literal: true

require 'avalon/routing/can_constraint'

Rails.application.routes.draw do
  mount Samvera::Persona::Engine => '/'
  mount Blacklight::Engine => '/catalog'
  concern :searchable, Blacklight::Routes::Searchable.new
  concern :exportable, Blacklight::Routes::Exportable.new

  resource :catalog, only: [:index], as: 'catalog', path: '/catalog', controller: 'catalog' do
    concerns :searchable
  end

  # For some reason this needs to be after `resource :catalog` otherwise Blacklight will generate links to / instead of /catalog
  root to: "catalog#index"

  get '/mejs/:version', to: 'application#mejs'

  resources :solr_documents, only: [:show], path: '/catalog', controller: 'catalog' do
    concerns :exportable
  end

  resources :encode_records, only: [:show, :index] do
    collection do
      post :paged_index
      post :progress
    end
  end

  resources :checkouts, only: [:index, :create, :show, :update, :destroy], :constraints => lambda { |request| Avalon::Configuration.controlled_digital_lending_enabled? } do
    collection do
      patch :return_all
    end

    member do
      patch :return
    end
  end

  resources :bookmarks do
    concerns :exportable

    collection do
      delete 'clear'
      get 'delete'#, as: :delete_bookmarks
      post 'delete'
      get 'move'#, as: :move_bookmarks
      post 'move'
      get 'update_access_control'#, as: :update_access_control_bookmarks
      post 'update_access_control'
      post 'publish'#, as: :publish_bookmarks
      post 'unpublish'#, as: :unpublish_bookmarks
      get 'add_to_playlist'
      post 'add_to_playlist'
      get 'intercom_push'
      post 'intercom_push'
      get 'merge'
      post 'merge'
      get 'count', constraints: { format: 'json' }
    end
  end

  devise_for :users, controllers: { omniauth_callbacks: 'users/omniauth_callbacks', sessions: 'users/sessions' }
  devise_scope :user do
    Avalon::Authentication::Providers.collect { |provider| provider[:provider] }.uniq.each do |provider_name|
      match "/users/auth/#{provider_name}/callback", to: "users/omniauth_callbacks##{provider_name}", as: "user_omniauth_callback_#{provider_name}".to_sym, via: [:get, :post]
    end
  end

  mount BrowseEverything::Engine => '/browse'

  # Avalon routes
  match "/authorize", to: 'derivatives#authorize', via: [:get, :post]
  match "/authorize/:path", to: 'derivatives#authorize', via: [:get, :post]

  namespace :admin do
    resources :groups, except: [:show] do
      collection do
        put 'update_multiple'
      end
      member do
        put 'update_users'
      end
    end
    resources :collections do
      member do
        get 'edit'
        get 'remove'
        get 'items'
        get 'poster'
        post 'poster', action: :attach_poster, as: 'attach_poster'
        delete 'poster', action: :remove_poster, as: 'remove_poster'
      end
    end

    namespace :migration_report, controller: '/migration_status' do
      get '/', action: :index
      get ':class', action: :show, as: 'by_class'
      get ':id/detail', action: :detail, as: 'detail'
      get ':id/report', action: :report, as: 'report'
    end
  end

  resources :vocabulary, except: [:create, :destroy, :new, :edit]

  resources :collections, only: [:index, :show] do
    member do
      get :poster
    end
  end

  resources :media_objects, except: [:create, :update] do
    member do
      put :update, action: :update, defaults: { format: 'html' }, constraints: { format: 'html' }
      put :update, action: :json_update, constraints: { format: 'json' }
      patch :update, action: :update, defaults: { format: 'html' }, constraints: { format: 'html' }
      put :update_status
      get :progress, :action => :show_progress
      get 'content/:file', :action => :deliver_content, :as => :inspect
      get 'track/:part', :action => :show, :as => :indexed_section
      get 'section/:content', :action => :show, :as => :id_section
      get 'section/:content/stream', :action => :show_stream_details, :as => :section_stream
      get 'section/:content/embed', :to => redirect('/master_files/%{content}/embed')
      get 'tree', :action => :tree, :as => :tree
      get :confirm_remove
      post :add_to_playlist
      patch :intercom_push
      get :manifest
      get :move_preview, defaults: { format: 'json' }, constraints: { format: 'json' }
    end
    collection do
      post :create, action: :create, constraints: { format: 'json' }
      post :set_session_quality
      get :confirm_remove
      put :update_status
      # 'delete' has special signifigance so use 'remove' for now
      delete :remove, :action => :destroy
      get :intercom_collections
    end

    # Supplemental Files
    resources :supplemental_files, except: [:new, :index, :edit] do
      get :index, constraints: { format: 'json' }, on: :collection
    end
  end

  resources :master_files, except: [:new, :index] do
    member do
      get  'thumbnail', :to => 'master_files#get_frame', :defaults => { :type => 'thumbnail' }
      get  'poster',    :to => 'master_files#get_frame', :defaults => { :type => 'poster' }

      post 'thumbnail', :to => 'master_files#set_frame', :defaults => { :type => 'thumbnail', :format => 'html' }
      post 'poster',    :to => 'master_files#set_frame', :defaults => { :type => 'poster', :format => 'html' }
      post 'still',     :to => 'master_files#set_frame', :defaults => { :format => 'html' }
      get :embed
      post 'attach_structure'
      get :captions
      get :waveform
      match ':quality.m3u8', to: 'master_files#hls_manifest', via: [:get], as: :hls_manifest
      get 'structure', to: 'master_files#structure', constraints: { format: 'json' }
      post 'structure', to: 'master_files#set_structure', constraints: { format: 'json' }
      delete 'structure', to: 'master_files#delete_structure', constraints: { format: 'json' }
      post 'move'
      get 'transcript/:t_id', to: 'master_files#transcript'
      get :search
      
      if Settings.derivative.allow_download
        get :download_derivative
      end
    end

    # Supplemental Files
    resources :supplemental_files, except: [:new, :index, :edit] do
      member do
        get 'captions'
        get 'transcripts', :to => redirect('/master_files/%{master_file_id}/supplemental_files/%{id}')
      end
      get :index, constraints: { format: 'json' }, on: :collection
    end
  end

  match "iiif_auth_token/:id", to: 'master_files#iiif_auth_token', via: [:get], as: :iiif_auth_token

  resources :derivatives, only: [:create]
  match "/autocomplete", to: 'objects#autocomplete', via: [:get]
  match "/objects/:id", to: 'objects#show', via: [:get], :as => :objects
  match "/object/:id", to: 'objects#show', via: [:get]

  resources :playlists do
    resources :playlist_items, path: 'items', only: [:create, :update, :show] do
      get 'related_items'
    end
    member do
      patch 'update_multiple'
      delete 'update_multiple'
      patch 'regenerate_access_token'
      get 'refresh_info'
      get 'manifest'
    end
    collection do
      post 'duplicate'
      post 'paged_index'
      if Settings['variations'].present?
        post 'import_variations_playlist'
      end
    end
  end

  resources :avalon_marker, only: [:create, :show, :update, :destroy]

  resources :comments, only: [:index, :create]

  resources :playlist_items, only: [:update], :constraints => {:format => /(js|json)/}

  resources :timelines do
    member do
      patch 'regenerate_access_token'
      post 'manifest', to: 'timelines#manifest_update', constraints: { format: 'json' }
      get 'manifest'
    end
    collection do
      post 'duplicate'
      post 'paged_index'
      if Settings['variations'].present?
        post 'import_variations_timeline'
      end
    end
  end
  get '/timeliner', to: 'timelines#timeliner', as: :timeliner

  resources :dropbox, :only => [] do
    collection do
      delete :bulk_delete
    end
  end

  match "/oembed", to: 'master_files#oembed', via: [:get]

  constraints(Avalon::Routing::CanConstraint.new(:read, :about_page)) do
    mount AboutPage::Engine => '/about(.:format)', as: 'about_page'
  end
  get '/about(.:format)', to: redirect('/')
  get '/about/health.yaml', to: 'about_page/about#health', defaults: { :format => 'yaml' }
  get '/about/health(.:format)', to: redirect('/')

  constraints(Avalon::Routing::CanConstraint.new(:manage, :jobs)) do
    mount Sidekiq::Web, at: '/jobs', as: 'jobs'
  end
  get '/jobs(.:format)', to: redirect('/')

  scope :persona, as: 'persona' do
    resources :users, only: [:paged_index], controller: 'samvera/persona/users' do
      collection do
        post 'paged_index'
      end
    end
  end
end

app/models/playlist.rb
# Copyright 2011-2024, The Trustees of Indiana University and Northwestern
#   University.  Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
# 
# You may obtain a copy of the License at
# 
# http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software distributed
#   under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
#   CONDITIONS OF ANY KIND, either express or implied. See the License for the
#   specific language governing permissions and limitations under the License.
# ---  END LICENSE_HEADER BLOCK  ---

class Playlist < ActiveRecord::Base
  belongs_to :user
  scope :by_user, ->(user) { where(user_id: user.id) }
  scope :title_like, ->(title_filter) do
    term_array = title_filter.split.map { |term| "%#{sanitize_sql_like(term).downcase}%" }
    query = Array.new(term_array.size, "LOWER(title) LIKE ?").join(" AND ")
    where(query, *term_array)
  end
  scope :with_tag, ->(tag_filter) { where("tags LIKE ?", "%\n- #{tag_filter}\n%") }

  validates :user, presence: true
  validates :title, presence: true
  validates :visibility, presence: true
  validates :visibility, inclusion: { in: proc { [PUBLIC, PRIVATE, PRIVATE_WITH_TOKEN] } }

  delegate :url_helpers, to: 'Rails.application.routes'

  after_initialize :default_values
  before_save :generate_access_token, if: Proc.new{ |p| p.visibility == Playlist::PRIVATE_WITH_TOKEN && access_token.blank? }

  has_many :items, -> { order('position ASC') }, class_name: 'PlaylistItem', dependent: :destroy
  has_many :clips, -> { order('playlist_items.position ASC') }, class_name: 'AvalonClip', through: :items
  accepts_nested_attributes_for :items, allow_destroy: true

  serialize :tags

  # visibility
  PUBLIC = 'public'
  PRIVATE = 'private'
  PRIVATE_WITH_TOKEN = 'private-with-token'

  # Default values to be applied after initialization
  def default_values
    self.visibility ||= Playlist::PRIVATE
    self.tags ||= [];
  end

  def generate_access_token
    # TODO Use ActiveRecord's secure_token when we move to Rails 5
    self.access_token = loop do
      random_token = SecureRandom.urlsafe_base64(nil, false)
      break random_token unless self.class.exists?(access_token: random_token)
    end
  end

  # Returns all other playlist items on the same playlist that share a master file
  # @param [PlaylistItem] current_item The playlist item you want to find matches for
  # @return [Array <PlaylistItem>] an array of all other playlist items that reference the same master file
  def related_items(current_item)
    uri = AvalonClip.where(id: current_item.clip_id)[0].source
    items = PlaylistItem.joins(:clip).where('annotations.source_uri' => uri).where(playlist: self)
    # remove the current item
    return_items = []
    items.each do |item|
      return_items << item unless item.clip_id == current_item.clip_id
    end
    return_items
  end

  # Returns all other clips on the same playlist that share a master file
  # @param [PlaylistItem] current_item The playlist item you want to find matches for
  # @return [Array <AvalonClip>] an array of all other clips items that reference the same master file
  def related_clips(current_item)
    clips = []
    related_items(current_item).each do |item|
      clips << AvalonClip.find(item.clip_id)
    end
    clips
  end

  # Returns a list of clips that are on the same playlist, share the same masterfile, and whose start time falls within the start and end time of the current playlist item
  # @param [PlaylistItem] current_item The playlist item to match against
  # @return [Array <AvalonClip>] all clips matching the constraints
  def related_clips_time_contrained(current_item)
    current_clip = AvalonClip.where(id: current_item.clip_id)[0]
    clips = []
    related_items(current_item).each do |item|
      clip = AvalonClip.where(id: item.clip_id)[0]
      clips << clip if clip.start_time <= current_clip.end_time && clip.start_time >= current_clip.start_time
    end
    clips
  end

  def valid_token?(token)
    access_token == token && visibility == Playlist::PRIVATE_WITH_TOKEN
  end

  class << self
    # Find the i18n default playlist name
    def default_folder_name
      I18n.translate(:'playlists.default_playlist_name')
    end
  end # class << self
end

app/helpers/playlists_helper.rb
# Copyright 2011-2024, The Trustees of Indiana University and Northwestern
#   University.  Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
# 
# You may obtain a copy of the License at
# 
# http://www.apache.org/licenses/LICENSE-2.0
# 
# Unless required by applicable law or agreed to in writing, software distributed
#   under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
#   CONDITIONS OF ANY KIND, either express or implied. See the License for the
#   specific language governing permissions and limitations under the License.
# ---  END LICENSE_HEADER BLOCK  ---

module PlaylistsHelper
  def human_friendly_visibility(visibility)
    content_tag(:span,
      safe_join([icon_only_visibility(visibility),t("playlist.#{visibility}Text")], ' '),
      class: "human_friendly_visibility_#{visibility}",
      title: visibility_description(visibility))
  end

  def icon_only_visibility(visibility)
    icon = case visibility
      when Playlist::PUBLIC
        "fa-globe"
      when Playlist::PRIVATE
        "fa-lock"
      else
        "fa-link"
    end
    content_tag(:span, '', class:"fa #{icon} fa-lg", title: visibility_description(visibility))
  end

  def visibility_description(visibility)
    t("playlist.#{visibility}AltText")
  end
end

app/views/playlists/_action_buttons.html.erb
<%#
Copyright 2011-2024, The Trustees of Indiana University and Northwestern
  University.  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.

You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed
  under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
  CONDITIONS OF ANY KIND, either express or implied. See the License for the
  specific language governing permissions and limitations under the License.
---  END LICENSE_HEADER BLOCK  ---
%>

<div class="row playlist-action-buttons">
  <div class="col-sm-6">
    <% if current_ability.can? :edit, @playlist %>
    <div id="edit-playlist-button">
      <%= link_to edit_playlist_path(@playlist), class: "btn btn-primary btn-block text-nowrap" do %>
      <i class="fa fa-edit" aria-hidden="true"></i> Edit Playlist
      <% end %>
    </div>
    <% end %>
  </div>
  <div class="col-sm-6">
    <% if current_ability.can? :duplicate, @playlist %>
    <%= button_tag( type: 'button', data: { playlist: @playlist }, class: 'copy-playlist-button btn btn-outline btn-block text-nowrap') do %>
    <i class="fa fa-clone" aria-hidden="true"></i> Copy Playlist
    <% end %>
    <% end %>
  </div>
</div>

<% if current_ability.can? :duplicate, @playlist %>
<%= render partial: 'copy_playlist_modal', locals: { with_refresh: false } %>
<% end %>

<% content_for :page_scripts do %>
<script>
  $(document).ready(function () {
    window.add_copy_playlist_button_event()
  });
</script>
<% end %>

app/views/playlists/_lti_url.html.erb
<%#
Copyright 2011-2024, The Trustees of Indiana University and Northwestern
  University.  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.

You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed
  under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
  CONDITIONS OF ANY KIND, either express or implied. See the License for the
  specific language governing permissions and limitations under the License.
---  END LICENSE_HEADER BLOCK  ---
%>
<% if section=='tab-content' %>
  <div class="tab-pane text-left" id="lti-tab">
    <% if @playlist.visibility == Playlist::PUBLIC %>
    <p class="muted">Copy the link below to share this playlist via LTI</p>
    <form role="form">
      <div class="form-group">
        <input type="text" class="col-md-5 form-control" id="ltilink-object" value="<%= lti_share_url_for(@playlist) %>" onClick="this.select();" readonly="readonly">
      </div>
    </form>
    <% elsif @playlist.visibility == Playlist::PRIVATE_WITH_TOKEN %>
    <p class="muted">Copy the link below to share this playlist via LTI.  It can only be seen and shared by people with this link.</p>
    <form role="form">
      <div class="form-group">
        <input type="text" class="col-md-5 form-control" id="ltilink-object" value="<%= lti_share_url_for(@playlist, token: @playlist.access_token) %>" onClick="this.select();" readonly="readonly">
      </div>
    </form>
    <% else %>
    <p class="muted">This playlist is private.  To enable sharing, change the visibility setting within the <%= link_to "Edit Playlist", edit_playlist_url(@playlist) %> page.</p>
    <% end %>
  </div>
<% elsif section=='share-tabs' %>
  <a class="nav-link nav-item" href="#lti-tab" data-toggle="tab">LTI URL</a>
<% end %>

app/views/playlists/_share.html.erb
<%#
Copyright 2011-2024, The Trustees of Indiana University and Northwestern
  University.  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.

You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed
  under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
  CONDITIONS OF ANY KIND, either express or implied. See the License for the
  specific language governing permissions and limitations under the License.
---  END LICENSE_HEADER BLOCK  ---
%>
<div id="share-list">
    <nav class="nav nav-tabs share-tabs">
      <%= render_conditional_partials :share, section:'share-tabs' %>
    </nav>

    <div class="tab-content">
      <%= render_conditional_partials :share, section:'tab-content' %>
    </div>
  </div>

<% content_for :page_scripts do %>

<script>
  $(document).ready(function() {
    setInterval(shareResourceListener, 500);

    function shareResourceListener() {
      if(!$('nav.share-tabs').first().hasClass('active')) {
        $('nav.share-tabs').first().toggleClass('active');
        $('.share-tabs a').first().attr('aria-selected', true);
        $('#share-list .tab-content .tab-pane').first().toggleClass('active');
      }

      $('.share-tabs a').click(function (e) {
        e.preventDefault();
        $(this).tab('show');
        $('.share-tabs a').attr('aria-selected', false);
        $(this).attr('aria-selected', true);
      });
    }
  })
</script>

<% end %>

app/views/playlists/_share_resource.html.erb
<%#
Copyright 2011-2024, The Trustees of Indiana University and Northwestern
  University.  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.

You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed
  under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
  CONDITIONS OF ANY KIND, either express or implied. See the License for the
  specific language governing permissions and limitations under the License.
---  END LICENSE_HEADER BLOCK  ---
%>
<% if section=='tab-content' %>
  <div class="tab-pane text-left" id="link-tab">
    <% if @playlist.visibility == Playlist::PUBLIC %>
    <p class="muted">Copy the link below to share this playlist</p>
    <form role="form">
      <div class="form-group">
        <input type="text" class="form-control" id="link-object" value="<%= playlist_url(@playlist) %>" placeholder="<%= playlist_url(@playlist) %>" onClick="this.select();" readonly="readonly">
      </div>
    </form>
    <% elsif @playlist.visibility == Playlist::PRIVATE_WITH_TOKEN %>
    <p class="muted">Copy the link below to share this playlist.  It can only be seen and shared by people with this link.</p>
    <form role="form">
      <div class="form-group">
        <input type="text" class="form-control" id="link-object" value="<%= access_token_url(@playlist) %>" placeholder="<%= access_token_url(@playlist) %>" onClick="this.select();" readonly="readonly">
      </div>
    </form>
    <% else %>
    <p class="muted">This playlist is private.  To enable sharing, change the visibility setting within the <%= link_to "Edit Playlist", edit_playlist_url(@playlist) %> page.</p>
    <% end %>
  </div>
<% elsif section=='share-tabs' %>
  <a class="nav-link nav-item active" href="#link-tab" data-toggle="tab">Share this playlist</a>
<% end %>

app/views/playlists/import_variations_playlist.html.erb
<%#
Copyright 2011-2024, The Trustees of Indiana University and Northwestern
  University.  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.

You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed
  under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
  CONDITIONS OF ANY KIND, either express or implied. See the License for the
  specific language governing permissions and limitations under the License.
---  END LICENSE_HEADER BLOCK  ---
%>
<div class="col-md-9 col-sm-8">
  <h1>Import Results</h1>
  <p>The following errors were encountered in the playlist file.</p>
  <div class="card" style="background-color:#F9F9F9;">
    <div class="card-body">
      <% playlist.items.each do |item| %>
        <% if item.clip.valid? && item.valid? %>
          <div><p style="font-weight: bold"><i class='fa fa-plus-circle success-color'></i> <%= item.title %></p></div>
        <% else %>
          <div>
            <p style="font-weight: bold"><i class='fa fa-times-circle danger-color'></i> <%= item.title %></p>
            <% if item.clip.errors.full_messages.include? "Master file field is required." %>
              <ul><li>No matching item found</li></ul>
            <% else %>
              <ul>
                <% item.errors.full_messages.select{|m|m!="Marker is invalid"}.each do |m| %>
                  <li><%= m %></li>
                <% end %>
                <% item.clip.errors.full_messages.each do |m| %>
                  <li><%= m %></li>
                <% end if !item.clip.valid?%>
                <% if item.errors.full_messages.include? "Marker is invalid" %>
                  <% item.marker.select{|m|!m.valid?}.each do |marker| %>
                    <li>Marker: <%= marker.title %>
                      <% if marker.errors.full_messages.include? "Master file field is required." %>
                        <ul><li>Master file field is required.</li></ul>
                      <% else %>
                        <ul>
                          <% marker.errors.full_messages.each do |m| %>
                            <li><%= m %></li>
                          <% end %>
                        </ul>
                      <% end %>
                    </li>
                  <% end %>
                <% end %>
              </ul>
            <% end %>
          </div>
        <% end %>
      <% end %>
    </div>
  </div>
  <br>
  <div class="col-lg-7">
    <p>This playlist is still able to be imported, but due to these errors will not contain the items above; other problems may be present as a result.</p>
    <p>For technical assistance regarding these errors please use our <strong><a href="/comments">contact form</a></strong>.</p>
    <br>
  </div>
  <div class = "col-lg-7">
    <a href="/playlists/" class="btn btn-danger">Cancel</a>
    <%= form_tag(import_variations_playlist_playlists_path, method:"post", style:"display:inline") do %>
      <input type="submit" class="btn btn-outline" value="Import"/>
      <input type="hidden" name="skip_errors" value="true"/>
    <% end %>
  </div>
</div>

app/views/playlists/index.html.erb
<%#
Copyright 2011-2024, The Trustees of Indiana University and Northwestern
  University.  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.

You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed
  under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
  CONDITIONS OF ANY KIND, either express or implied. See the License for the
  specific language governing permissions and limitations under the License.
---  END LICENSE_HEADER BLOCK  ---
%>

<% if current_user.nil? %>
<%= link_to 'Please login to view your playlists.', new_user_session_path %>
<% end %>
<% unless current_user.nil? %>
  <% playlists = Playlist.where(user_id: current_user.id) %>
  <div class="Playlist-index">
    <div class="page-title-wrapper mb-3">
      <div class="row">
        <div class="col-sm-6">
          <h1 class="page-title">Playlists <small>(<%= playlists.size %> total)</small></h1>
        </div>
          <div class="<% if !playlists.empty? %>col-sm-6 text-right<% end %>">
            <div class="create-buttons">
              <%= link_to('<span class="btn btn-primary headline-button">Create New Playlist</span>'.html_safe, new_playlist_path) %>
              <% if Settings['variations'].present? %>
                <%= form_tag(import_variations_playlist_playlists_path, method:"post", enctype:"multipart/form-data", style:"display:inline") do %>
                  <input type="file" name="Filedata" class="filedata" style="visibility:hidden; display:inline; width:0;" />
                  <input type="button" class="btn btn-primary" id="variations_import"
                    onclick="$(this).closest('form').find('.filedata').click();" value="Import Variations Playlist" />
                <% end %>
              <% end %>
            </div>
          </div>
      </div>
    </div>

    <% unless playlists.empty? %>
      <div class="tag_filter_container">
        Filter by tag: <select name="tag_filter" class="tag_filter form-control input-sm" style="width:auto">
          <option value="" selected="selected">None</option>
          <% current_user.playlist_tags.each do |tag| %>
          <option value="<%= tag %>"><%= tag %></option>
          <% end %>
        </select>
      </div>
      <table id="Playlists" class="table table-striped dataTable">
        <thead>
          <tr>
            <th>Name</th>
            <th>Size</th>
            <th>Visibility</th>
            <th>Created</th>
            <th>Updated</th>
            <th>Tags</th>
            <th class="text-right" data-orderable="false">Actions</th>
          </tr>
        </thead>
        <tbody>
        </tbody>
      </table>
    <% end %>
  </div>
  <% unless !playlists.empty? %>
  <% end %>
<% end %>

<%= render partial: 'copy_playlist_modal', locals: { with_refresh: true } %>

<% content_for :page_scripts do %>
<script>
  $(document).ready(function () {
    $('#Playlists').DataTable({
      processing: true,
      serverSide: true,
        dom:'<"dataTableToolsTop"if><"dataTableBody"t><"dataTableToolsBottom"rlp>',
      autoWidth:true,
      ajax: {
        url: '/playlists/paged_index',
        type: 'POST'
      },
      order: [ <%= "[#{session[:playlist_sort][0]}, '#{session[:playlist_sort][1]}']".html_safe if session[:playlist_sort] %>
      ],
      "columns": [
        null,
        null,
        null,
        null,
        null,
        null,
        {
          className: "text-right"
        }
      ]
    }).on('draw', function () {
      window.apply_button_confirmation()
      window.add_copy_playlist_button_event()
      // move the tag filter into the datatables layout
      $('.tag_filter_container').insertBefore('.dataTables_filter');
    });
  });

  $('.tag_filter').change(function () {
    $.fn.dataTable.tables({
      api: true
    }).columns(5).search($(this).val()).draw();
  })

  $('.filedata').change(function () {
    $(this).closest('form').submit();
  });
</script>
<% end %>